"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPrivateNode = isPrivateNode;
exports.isStaticNode = isStaticNode;
exports.getExtendsClause = getExtendsClause;
exports.getExtendedNode = getExtendedNode;
exports.getExtendedType = getExtendedType;
const ts = require("typescript");
function isPrivateNode(node) {
    var _a;
    return ((_a = node.modifiers) === null || _a === void 0 ? void 0 : _a.some(m => m.kind === ts.SyntaxKind.PrivateKeyword)) === true;
}
function isStaticNode(node) {
    var _a;
    return ((_a = node.modifiers) === null || _a === void 0 ? void 0 : _a.some(m => m.kind === ts.SyntaxKind.StaticKeyword)) === true;
}
function getExtendsClause(node) {
    var _a;
    return (_a = node.heritageClauses) === null || _a === void 0 ? void 0 : _a.find(clause => clause.token === ts.SyntaxKind.ExtendsKeyword);
}
function getExtendedNode(node) {
    const extendsClause = getExtendsClause(node);
    if (!extendsClause)
        return;
    return extendsClause.types[0];
}
function getExtendedType(context, node) {
    const extendedNode = getExtendedNode(node);
    return extendedNode && context.checker.getTypeAtLocation(extendedNode);
}
//# sourceMappingURL=utils.js.map